#include "ThreadBinaryTree.h"

Stack stack;        // Stack. Used to store nodes

int main(int argc, char* argv[])
{	
	PBiThrTree pTree; // pointer to a clue binary tree
	PBiThrTree pHead; // The head pointer to the clue binary tree
	
	//
	// Initialize the stack
	//
	InitStack(&stack);  

	//
	// 
	//	
	pTree = InitTree();
		                                           
	//
	// 
	//
	pHead = CreateNode(0);
			
	InOrderThreading(pHead, pTree);
		
	return 0;
}

/*
function:
	Middle order traverses binary trees pTree ,,pHead ָͷڵ.

parameter:
	pTree -- pointer to a clue binary tree.
	pHead -- pointer to a clue binary tree,ָͷڵ
	
returned value:
	ɹ 1.
	ʧܷ 0.
*/
int InOrderThreading(PBiThrTree pHead, PBiThrTree pTree)  
{
	BiThrNode* pNode;      // Pointer to the clue binary tree node
	BiThrNode* pPre;	   // pPre ָָոշʹĽڵ

	
	//
	// TODO: Add the code here
	//
	
	
	OutputResult(pHead, pTree);

	return 0;			
}

/*
function:
	һڵ.

parameter:
	data -- Binary tree nodes store data
  
returned value:
	Return node pointer
*/
BiThrNode* CreateNode(ElemType data)
{
	BiThrNode* pNode = (BiThrNode*)malloc(sizeof(BiThrNode));
	
	pNode->data = data;
	pNode->lchild = NULL;
	pNode->rchild = NULL;
	pNode->ltag = 0;
	pNode->rtag = 0;
	
	return pNode;
}

/*
function:
	öдһö.
  
returned value:
	pointer to a binary tree
*/
static const char* data = "-+ *b  -c  d  /e"; // A binary tree preordered sequence string.
													  // notice:Using only preordered sequences does not determine a unique binary tree.
												      // So, two Spaces after the leaf node,
													  // Also, the sequence ends with the character '\0' at the end of the string.
												      // In this way, the preordering sequence determines the unique binary tree.
static int nIndex = 0;	// The index of the binary tree first order sequence
PBiThrTree InitTree()
{
	BiThrNode* pRootNode;
	
	if('\0' == data[nIndex])	// End of preordering sequence string of binary tree
		pRootNode = NULL;		
	else
	{
		//
		// Create parent node
		//
		pRootNode = (' ' == data[nIndex] ? NULL : CreateNode(data[nIndex]));	// Empty nodes must be ignored
		nIndex++;
	}
	
	if(pRootNode != NULL)
	{
		//
		// Recursion is used to implement the first order traversal algorithm
		//
		pRootNode->lchild = InitTree();
		pRootNode->rchild = InitTree();
	}
	
	return pRootNode;
}

void OutputResult(PBiThrTree pHead, PBiThrTree pTree)
{
	BiThrNode* pNode2;  
	BiThrNode* pPreNode2;  
	
	if(pHead->lchild == NULL)
	{
		return 0;
	}	

	pNode2 = pHead->lchild;
	pPreNode2 = NULL;
	while(1)
	{	
		while(1)
		{
			if(pNode2->ltag == 0 && (pPreNode2 == NULL || pPreNode2 != pNode2->lchild))
			{
				pNode2 = pNode2->lchild;					
			}
			else if(pNode2->rtag == 0)
			{
				printf("%c ", pNode2->data);
				pNode2 = pNode2->rchild;
			}
			else
			{
				break;
			}
		}
		
		printf("%c ", pNode2->data);
		
		pPreNode2 = pNode2;
		
		pNode2 = pNode2->rchild;
		
		if(pNode2 == pTree)
		{
			if(pNode2->data != '\0')
				printf("%c ", pNode2->data);
			pNode2 = pNode2->rchild;
		}	
		if(pNode2 == pHead)
		{
			break;
		}		
	}
	
	printf("\n");
}
